import Command, { flags } from "@oclif/command";
import { ListrTask } from "listr";
import { GraphQLProject, GraphQLClientProject, ApolloConfig } from "apollo-language-server";
export interface ProjectContext<Flags = any, Args = any> {
    project: GraphQLProject;
    config: ApolloConfig;
    flags: Flags;
    args: Args;
}
export declare abstract class ProjectCommand extends Command {
    static flags: {
        config: flags.IOptionFlag<string | undefined>;
        service: flags.IOptionFlag<string | undefined>;
        endpoint: flags.IOptionFlag<string | undefined>;
        key: flags.IOptionFlag<string | undefined>;
        engine: flags.IOptionFlag<string | undefined>;
        frontend: flags.IOptionFlag<string | undefined>;
    };
    project: GraphQLProject;
    tasks: ListrTask[];
    protected type: "service" | "client";
    protected configMap?: (flags: any) => any;
    private ctx;
    init(): Promise<void>;
    protected createConfig(flags: any): Promise<{
        config: ApolloConfig;
        filepath: string;
        isEmpty: boolean | undefined;
    }>;
    protected createService(config: ApolloConfig, filepath: string, flags: any): void;
    runTasks<Result>(generateTasks: (context: ProjectContext) => ListrTask[]): Promise<Result>;
    catch(err: any): Promise<void>;
    finally(err: any): Promise<void>;
}
export declare abstract class ClientCommand extends ProjectCommand {
    static flags: {
        clientReferenceId: flags.IOptionFlag<string | undefined>;
        clientName: flags.IOptionFlag<string | undefined>;
        clientVersion: flags.IOptionFlag<string | undefined>;
        tag: flags.IOptionFlag<string | undefined>;
        config: flags.IOptionFlag<string | undefined>;
        service: flags.IOptionFlag<string | undefined>;
        endpoint: flags.IOptionFlag<string | undefined>;
        key: flags.IOptionFlag<string | undefined>;
        engine: flags.IOptionFlag<string | undefined>;
        frontend: flags.IOptionFlag<string | undefined>;
    };
    project: GraphQLClientProject;
    constructor(argv: any, config: any);
}
//# sourceMappingURL=Command.d.ts.map